#! /usr/bin/env python
from template import Section

### Functions/classes for printing misc. sections of the config

### Generates the module section
class Modules:
	def __init__(self):
		self.modules = []

	def add(self, module):
		self.modules.append(module)
	
	def rm(self, module):
		if self.modules.count(module):
			self.modules.remove(module)

	def get_section(self):
		section = Section()
		section.name("Module")

		for m in self.modules:
			section.add('Load\t\t"' + m + '"')

		return section.get_section()

### Generates the server layout section
def get_server_layout():
	config = 'Section "ServerLayout"\n'
	config = config + '\tIdentifier\t"XAC Configured"\n'
	config = config + '\tScreen\t\t0 "Screen0" 0 0\n'
	config = config + '\tInputDevice\t"Mouse0"\t"CorePointer"\n'
	config = config + '\tInputDevice\t"Keyboard0"\t"CoreKeyboard"\n'
	config = config + 'EndSection\n\n'
	return config

### Generates the "ServerFlags" section
### c is the current config
def get_server_flags(c):
	config = Section()
	config.name('ServerFlags')
	config.item('Option\t\t')
	config.addi('"blank time"\t"' + str(c.blank_time) + '"\t# ' + str(c.blank_time) + ' Minutes')
	config.addi('"standby time"\t"' + str(c.standby_time) + '"\t# ' + str(c.standby_time) + ' Minutes')
	config.addi('"suspend time"\t"' + str(c.suspend_time) + '"\t# ' + str(c.suspend_time) + 'Minutes')
	config.addi('"off time"\t"' + str(c.off_time) + '"\t# ' + str(c.off_time) + 'Minutes')
	config.add('Uncomment so X doesn\'t fail when no mouse is available',3)
	if c.mouse_fail:
		config.addi('"AllowMouseOpenFail"\t"true"')
	else:
		config.addi('"AllowMouseOpenFail"\t"true"', 1)
		
	config.add('Enable this option if X should not change resolutions',3)
	config.add('This is useful if mode changing corrupts the X Server',3)
	if c.allow_mode_change:
		config.addi('"DisableVidModeExtensions"\t"true"', 1)
	else:
		config.addi('"DisableVidModeExtensions"\t"true"')
	return config.get_section()

### Generates the DRI permissions section
def get_dri_section():
	config = Section()
	config.name('DRI')
	config.add('Group 0')
	config.add('Mode 0666')
	return config.get_section()
